diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salnstimer.mm ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salnstimer.mm
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salnstimer.mm	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salnstimer.mm	2007-10-23 16:05:13.000000000 +0200
@@ -0,0 +1,66 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+// MARKER(update_precomp.py): autogen include statement, do not remove
+#include "precompiled_vcl.hxx"
+
+#include "saltimer.h"
+#include "salnstimer.h"
+#include "salinst.h"
+#include "saldata.hxx"
+
+#include "vcl/svdata.hxx"
+
+@implementation TimerCallbackCaller
+-(void)timerElapsed:(NSTimer*)pTimer
+{
+    if( AquaSalTimer::bDispatchTimer && ! AquaSalTimer::bTimerInDispatch )
+    {
+        ImplSVData* pSVData = ImplGetSVData();
+        if( pSVData->mpSalTimer )
+        {
+            YIELD_GUARD;
+            AquaSalTimer::bTimerInDispatch = true;
+            pSVData->mpSalTimer->CallCallback();
+            AquaSalTimer::bTimerInDispatch = false;
+            
+            // NSTimer does not end nextEventMatchingMask of NSApplication
+            // so we need to wakeup a waiting Yield to inform it something happened
+            GetSalData()->mpFirstInstance->wakeupYield();
+        }
+    }
+}
+@end
+
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salsys.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salsys.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/salsys.cxx	2007-10-09 17:13:43.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/salsys.cxx	2007-10-18 17:34:18.000000000 +0200
@@ -97,7 +97,7 @@
 Rectangle AquaSalSystem::GetDisplayScreenPosSizePixel( unsigned int nScreen )
 {
 	CGRect aRect( CGDisplayBounds ( CGMainDisplayID() ) );
-	Rectangle aRet( aRect.origin.x, aRect.origin.y, aRect.origin.x + aRect.size.width, aRect.origin.y + aRect.size.height );
+	Rectangle aRet(static_cast<long>(aRect.origin.x), static_cast<long>(aRect.origin.y), static_cast<long>(aRect.origin.x + aRect.size.width), static_cast<long>(aRect.origin.y + aRect.size.height));
 	AquaLog("AquaSalSystem::GetDisplayScreenPosSizePixel(%d) (%ld,%ld,%ld,%ld)\n", nScreen, aRet.nLeft, aRet.nTop, aRet.nRight, aRet.nBottom );
 	return aRet;
 }
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/saltimer.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/saltimer.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/saltimer.cxx	2007-10-09 17:13:56.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/saltimer.cxx	2007-10-15 15:24:25.000000000 +0200
@@ -37,64 +37,43 @@
 #include "precompiled_vcl.hxx"
 
 #include "saltimer.h"
+#include "salnstimer.h"
 #include "saldata.hxx"
 #include "salframe.h"
 #include "salinst.h"
 
 // =======================================================================
 
-static NSTimer* pRunningTimer = nil;
-static bool bDispatchTimer = false;
-static bool bTimerInDispatch = false;
+NSTimer* AquaSalTimer::pRunningTimer = nil;
+bool AquaSalTimer::bDispatchTimer = false;
+bool AquaSalTimer::bTimerInDispatch = false;
 
-@interface TimerCallbackCaller : NSObject
-{
-}
--(void)timerElapsed:(NSTimer*)pTimer;
-@end
-
-@implementation TimerCallbackCaller
--(void)timerElapsed:(NSTimer*)pTimer
-{
-    if( bDispatchTimer && ! bTimerInDispatch )
-    {
-        ImplSVData* pSVData = ImplGetSVData();
-        if( pSVData->mpSalTimer )
-        {
-            YIELD_GUARD;
-            bTimerInDispatch = true;
-            pSVData->mpSalTimer->CallCallback();
-            bTimerInDispatch = false;
-        }
-    }
-}
-@end
 
 void ImplSalStartTimer( ULONG nMS )
 {
     SalData* pSalData = GetSalData();
     if( pSalData->mpFirstInstance->isNSAppThread() )
     {
-        bDispatchTimer = true;
+        AquaSalTimer::bDispatchTimer = true;
         NSTimeInterval aTI = double(nMS)/1000.0;
-        if( pRunningTimer != nil )
+        if( AquaSalTimer::pRunningTimer != nil )
         {
-            if( [pRunningTimer timeInterval] == aTI )
+            if( [AquaSalTimer::pRunningTimer timeInterval] == aTI )
                 // set new fire date
-                [pRunningTimer setFireDate: [NSDate dateWithTimeIntervalSinceNow: aTI]];
+                [AquaSalTimer::pRunningTimer setFireDate: [NSDate dateWithTimeIntervalSinceNow: aTI]];
             else
             {
-                [pRunningTimer invalidate];
-                pRunningTimer = nil;
+                [AquaSalTimer::pRunningTimer invalidate];
+                AquaSalTimer::pRunningTimer = nil;
             }
         }
-        if( pRunningTimer == nil )
+        if( AquaSalTimer::pRunningTimer == nil )
         {
-            pRunningTimer = [NSTimer scheduledTimerWithTimeInterval: aTI
-                                     target: [[[TimerCallbackCaller alloc] init] autorelease]
-                                     selector: @selector(timerElapsed:)
-                                     userInfo: nil
-                                     repeats: YES];
+            AquaSalTimer::pRunningTimer = [NSTimer scheduledTimerWithTimeInterval: aTI
+                                                   target: [[[TimerCallbackCaller alloc] init] autorelease]
+                                                   selector: @selector(timerElapsed:)
+                                                   userInfo: nil
+                                                   repeats: YES];
         }
     }
     else
@@ -117,7 +96,7 @@
 
 void ImplSalStopTimer()
 {
-    bDispatchTimer = false;
+    AquaSalTimer::bDispatchTimer = false;
 }
 
 void AquaSalTimer::handleStartTimerEvent( NSEvent* pEvent )
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/app/vclnsapp.mm ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/vclnsapp.mm
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/app/vclnsapp.mm	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/app/vclnsapp.mm	2007-10-16 15:10:08.000000000 +0200
@@ -0,0 +1,176 @@
+/*************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+ // MARKER(update_precomp.py): autogen include statement, do not remove
+#include "precompiled_vcl.hxx"
+
+#include "vclnsapp.h"
+#include "salinst.h"
+#include "saldata.hxx"
+#include "salframe.h"
+#include "salframeview.h"
+
+#include "vcl/window.hxx"
+#include "vcl/svapp.hxx"
+
+#include "rtl/ustrbuf.hxx"
+
+ 
+@implementation CocoaThreadEnabler
+-(void)enableCocoaThreads:(id)param
+{
+    // do nothing, this is just to start an NSThread and therefore put
+    // Cocoa into multithread mode
+}
+@end
+
+@implementation VCL_NSApplication
+-(void)sendEvent:(NSEvent*)pEvent
+{
+    NSEventType eType = [pEvent type];
+    if( eType == NSApplicationDefined )
+        GetSalData()->mpFirstInstance->handleAppDefinedEvent( pEvent );
+    else if( eType == NSKeyDown && ([pEvent modifierFlags] & NSCommandKeyMask) != 0 )
+    {
+        NSWindow* pKeyWin = [NSApp keyWindow];
+        if( pKeyWin && [pKeyWin isKindOfClass: [SalFrameWindow class]] )
+        {
+            AquaSalFrame* pFrame = [(SalFrameWindow*)pKeyWin getSalFrame];
+            if( pFrame->mpParent && pFrame->mpParent->GetWindow()->IsInModalMode() )
+            {
+                // dispatch to view directly to avoid the key event being consumed by the menubar
+                [[pKeyWin contentView] keyDown: pEvent];
+                return;
+            }
+        }
+
+    }
+    else if( eType == NSScrollWheel )
+    {
+        // FIMXE: this is necessary on MacOS 10.4 only
+        // how do I find out the OS version ?
+        
+        NSWindow* pWin = [pEvent window];
+        // on Tiger wheel events do not reach non key windows
+        // which probably should be considered a bug
+        if( [pWin isKindOfClass: [SalFrameWindow class]] && [pWin canBecomeKeyWindow] == NO )
+        {
+            [[pWin contentView] scrollWheel: pEvent];
+            return;
+        }
+    }
+    [super sendEvent: pEvent];
+}
+
+-(NSMenu*)applicationDockMenu:(NSApplication *)sender
+{
+    return AquaSalInstance::GetDynamicDockMenu();
+}
+-(MacOSBOOL)application: (NSApplication*)app openFile: (NSString*)pFile
+{
+    const rtl::OUString aFile( GetOUString( pFile ) );
+	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
+                                                APPEVENT_OPEN_STRING, aFile );
+	AquaSalInstance::aAppEventList.push_back( pAppEvent );
+    return YES;
+}
+
+-(void)application: (NSApplication*) app openFiles: (NSArray*)files
+{
+    rtl::OUStringBuffer aFileList( 256 );
+    
+    NSEnumerator* it = [files objectEnumerator];
+    NSString* pFile = nil;
+    
+    while( (pFile = [it nextObject]) != nil )
+    {
+        if( aFileList.getLength() > 0 )
+            aFileList.append( sal_Unicode( APPEVENT_PARAM_DELIMITER ) );
+        aFileList.append( GetOUString( pFile ) );
+    }
+    // we have no back channel here, we have to assume success, in which case
+    // replyToOpenOrPrint does not need to be called according to documentation
+    // [app replyToOpenOrPrint: NSApplicationDelegateReplySuccess];
+	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
+                                                APPEVENT_OPEN_STRING, aFileList.makeStringAndClear() );
+	AquaSalInstance::aAppEventList.push_back( pAppEvent );
+}
+
+-(MacOSBOOL)application: (NSApplication*)app printFile: (NSString*)pFile
+{
+    const rtl::OUString aFile( GetOUString( pFile ) );
+	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
+                                                APPEVENT_PRINT_STRING, aFile );
+	AquaSalInstance::aAppEventList.push_back( pAppEvent );
+    return YES;
+}
+-(NSApplicationPrintReply)application: (NSApplication *) app printFiles:(NSArray *)files withSettings: (NSDictionary *)printSettings showPrintPanels:(MacOSBOOL)bShowPrintPanels
+{
+    // currently ignores print settings an bShowPrintPanels
+    rtl::OUStringBuffer aFileList( 256 );
+    
+    NSEnumerator* it = [files objectEnumerator];
+    NSString* pFile = nil;
+    
+    while( (pFile = [it nextObject]) != nil )
+    {
+        if( aFileList.getLength() > 0 )
+            aFileList.append( sal_Unicode( APPEVENT_PARAM_DELIMITER ) );
+        aFileList.append( GetOUString( pFile ) );
+    }
+	const ApplicationEvent* pAppEvent = new ApplicationEvent( String(), ApplicationAddress(),
+                                                APPEVENT_PRINT_STRING, aFileList.makeStringAndClear() );
+	AquaSalInstance::aAppEventList.push_back( pAppEvent );
+    // we have no back channel here, we have to assume success
+    // correct handling would be NSPrintingReplyLater and then send [app replyToOpenOrPrint]
+    return NSPrintingSuccess;
+}
+
+-(NSApplicationTerminateReply)applicationShouldTerminate: (NSApplication *) app
+{
+    const SalData* pSalData = GetSalData();
+	if( !pSalData->maFrames.empty() )
+    {
+        // we forward the signal; alas we have no answer
+        // we cancel the request; OOo will decide whether is shuts down or not
+		pSalData->maFrames.front()->CallCallback( SALEVENT_SHUTDOWN, NULL );
+        return NSTerminateCancel;
+    }
+    else
+        // no frame left to talk to -> we really should terminate
+        return NSTerminateNow;
+}
+@end
+
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/aquaprintview.mm ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/aquaprintview.mm
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/aquaprintview.mm	1970-01-01 01:00:00.000000000 +0100
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/aquaprintview.mm	2007-10-15 15:24:25.000000000 +0200
@@ -0,0 +1,80 @@
+/************************************************************************
+ *
+ *  OpenOffice.org - a multi-platform office productivity suite
+ *
+ *  $RCSfile$
+ *
+ *  $Revision$
+ *
+ *  last change: $Author$ $Date$
+ *
+ *  The Contents of this file are made available subject to
+ *  the terms of GNU Lesser General Public License Version 2.1.
+ *
+ *
+ *    GNU Lesser General Public License Version 2.1
+ *    =============================================
+ *    Copyright 2005 by Sun Microsystems, Inc.
+ *    901 San Antonio Road, Palo Alto, CA 94303, USA
+ *
+ *    This library is free software; you can redistribute it and/or
+ *    modify it under the terms of the GNU Lesser General Public
+ *    License version 2.1, as published by the Free Software Foundation.
+ *
+ *    This library is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *    Lesser General Public License for more details.
+ *
+ *    You should have received a copy of the GNU Lesser General Public
+ *    License along with this library; if not, write to the Free Software
+ *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ *    MA  02111-1307  USA
+ *
+ ************************************************************************/
+
+// MARKER(update_precomp.py): autogen include statement, do not remove
+#include "precompiled_vcl.hxx"
+
+#include "aquaprintview.h"
+#include "salprn.h"
+#include "vcl/impprn.hxx"
+
+@implementation AquaPrintView
+-(id)initWithQPrinter: (ImplQPrinter*)pPrinter withInfoPrinter: (AquaSalInfoPrinter*)pInfoPrinter
+{
+    NSRect aRect = { { 0, 0 }, [pInfoPrinter->getPrintInfo() paperSize] };
+    if( (self = [super initWithFrame: aRect]) != nil )
+    {
+        mpQPrinter = pPrinter;
+        mpInfoPrinter = pInfoPrinter;
+    }
+    return self;
+}
+
+-(MacOSBOOL)knowsPageRange: (NSRangePointer)range
+{
+    range->location = 1;
+    range->length = mpQPrinter->GetPrintPageCount();
+    return YES;
+}
+
+-(NSRect)rectForPage: (int)page
+{
+    NSRect aRect = { { 0, 0 }, [mpInfoPrinter->getPrintInfo() paperSize] };
+    return aRect;
+}
+
+-(NSPoint)locationOfPrintRect: (NSRect)aRect
+{
+    NSPoint aPoint = { 0, 0 };
+    return aPoint;
+}
+
+-(void)drawRect: (NSRect)rect
+{
+    NSPoint aPoint = [self locationOfPrintRect: rect];
+    mpQPrinter->PrintNextPage();
+}
+@end
+
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/makefile.mk ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/makefile.mk
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/makefile.mk	2007-07-05 10:24:00.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/makefile.mk	2007-10-15 15:24:25.000000000 +0200
@@ -65,6 +65,7 @@
             $(SLO)$/salgdi.obj            \
             $(SLO)$/salvd.obj             \
             $(SLO)$/salprn.obj            \
+            $(SLO)$/aquaprintview.obj     \
             $(SLO)$/salbmp.obj            \
             $(SLO)$/salogl.obj
 
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salatslayout.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salatslayout.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salatslayout.cxx	2007-10-09 17:14:08.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salatslayout.cxx	2007-10-18 17:35:17.000000000 +0200
@@ -400,7 +400,7 @@
 		nYOffset = mpDeltaY[ nStart ];
 
     // calculate absolute position in pixel units
-    const Point aRelativePos( Fix2Long(nXOffset*mfFontScale), Fix2Long(nYOffset*mfFontScale) );
+    const Point aRelativePos( Fix2Long(static_cast<long>(nXOffset*mfFontScale)), Fix2Long(static_cast<long>(nYOffset*mfFontScale)) );
     rPos = GetDrawPosition( aRelativePos );
 
 	// update return values {nGlyphIndex,nCharPos,nGlyphAdvance}
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salgdi.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salgdi.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salgdi.cxx	2007-10-09 17:14:59.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salgdi.cxx	2007-10-18 17:35:17.000000000 +0200
@@ -1335,9 +1335,9 @@
 void AquaSalGraphics::SetTextColor( SalColor nSalColor )
 {
     RGBColor color;
-    color.red     = (unsigned short) SALCOLOR_RED(nSalColor)   * 65535.0 / 255.0;
-    color.green   = (unsigned short) SALCOLOR_GREEN(nSalColor) * 65535.0 / 255.0;
-    color.blue    = (unsigned short) SALCOLOR_BLUE(nSalColor)  * 65535.0 / 255.0;
+    color.red     = (unsigned short) ( SALCOLOR_RED(nSalColor)   * 65535.0 / 255.0 );
+    color.green   = (unsigned short) ( SALCOLOR_GREEN(nSalColor) * 65535.0 / 255.0 );
+    color.blue    = (unsigned short) ( SALCOLOR_BLUE(nSalColor)  * 65535.0 / 255.0 );
 
     ATSUAttributeTag aTag = kATSUColorTag;
     ByteCount aValueSize = sizeof( color );
@@ -1382,15 +1382,15 @@
 	// convert quartz units to pixel units
 	// please see the comment in AquaSalGraphics::SetFont() for details
     const double fPixelSize = (mfFontScale * mfFakeDPIScale * fPointSize);
-    pMetric->mnAscent       = +(aMetrics.ascent  * fPixelSize + 0.5);
-    pMetric->mnDescent      = -(aMetrics.descent * fPixelSize + 0.5);
-    pMetric->mnExtLeading   = +(aMetrics.leading * fPixelSize + 0.5);
+    pMetric->mnAscent       = + static_cast<long>(aMetrics.ascent  * fPixelSize + 0.5);
+    pMetric->mnDescent      = - static_cast<long>(aMetrics.descent * fPixelSize + 0.5);
+    pMetric->mnExtLeading   = + static_cast<long>(aMetrics.leading * fPixelSize + 0.5);
     pMetric->mnIntLeading   = 0;
     // ATSFontMetrics.avgAdvanceWidth is obsolete, so it is usually set to zero
     // since ImplFontMetricData::mnWidth is only used for stretching/squeezing fonts
     // setting this width to the pixel height of the fontsize is good enough
 	// it also makes the calculation of the stretch factor simple
-    pMetric->mnWidth        = fPixelSize + 0.5;
+    pMetric->mnWidth        = static_cast<long>(fPixelSize + 0.5);
 
 	// apply the "CJK needs extra leading" heuristic if needed
 	if( mpMacFontData->HasCJKSupport() )
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salgdiutils.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salgdiutils.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salgdiutils.cxx	2007-10-09 17:15:12.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salgdiutils.cxx	2007-10-18 17:35:17.000000000 +0200
@@ -143,9 +143,10 @@
                 */
                 maXORClipMask.reset();
                 CGRect aBounds( maClippingRects.front() );
-                basegfx::B2IRange aRect( aBounds.origin.x, aBounds.origin.y,
-                                         aBounds.origin.x+aBounds.size.width,
-                                         aBounds.origin.y+aBounds.size.height );
+                basegfx::B2IRange aRect( static_cast<sal_Int32>(aBounds.origin.x),
+					  static_cast<sal_Int32>(aBounds.origin.y),
+                                         static_cast<sal_Int32>(aBounds.origin.x+aBounds.size.width),
+                                         static_cast<sal_Int32>(aBounds.origin.y+aBounds.size.height) );
                 maXORDevice = basebmp::subsetBitmapDevice( maXORDevice, aRect );
             }
         }
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salnativewidgets.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salnativewidgets.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salnativewidgets.cxx	2007-10-09 17:15:40.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salnativewidgets.cxx	2007-10-18 22:30:15.000000000 +0200
@@ -638,7 +638,7 @@
                     {
                         // translate the origin of the button from the half of the offset
                         // translation value must be an integrer
-                        int delta_y = floor((rc.size.height - max_height) / 2.0);
+                        int delta_y = static_cast<int>(floor((rc.size.height - max_height) / 2.0));
                         rc.origin.y += delta_y + 1;
 
                         // button height must be limited ( height value collected from OSXHIGuidelines )
@@ -737,7 +737,7 @@
             aTrackInfo.kind                 = (rc.size.height > 10) ? kThemeProgressBarLarge : kThemeProgressBarMedium;
             aTrackInfo.bounds               = rc;
             aTrackInfo.min                  = 0;
-            aTrackInfo.max                  = rc.size.width;
+            aTrackInfo.max                  = static_cast<SInt32>(rc.size.width);
             aTrackInfo.value                = nProgressWidth;
             aTrackInfo.reserved             = 0;
             aTrackInfo.bounds.origin.y     -= 2; // FIXME: magic for shadow
@@ -747,7 +747,7 @@
                 aTrackInfo.attributes      |= kThemeTrackRightToLeft;
             aTrackInfo.enableState          = (nState & CTRL_STATE_ENABLED) ? kThemeTrackActive : kThemeTrackInactive;
             aTrackInfo.filler1              = 0;
-            aTrackInfo.trackInfo.progress.phase   = CFAbsoluteTimeGetCurrent()*10.0;
+            aTrackInfo.trackInfo.progress.phase   = static_cast<UInt8>(CFAbsoluteTimeGetCurrent()*10.0);
             
             HIThemeDrawTrack( &aTrackInfo, NULL, mrContext, kHIThemeOrientationNormal );
             bOK = true;
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salprn.cxx ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salprn.cxx
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/gdi/salprn.cxx	2007-10-09 17:16:20.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/gdi/salprn.cxx	2007-10-18 17:35:17.000000000 +0200
@@ -38,6 +38,7 @@
 
 #include "salinst.h"
 #include "salprn.h"
+#include "aquaprintview.h"
 #include "salgdi.h"
 #include "saldata.hxx"
 #include "vcl/jobset.h"
@@ -45,57 +46,6 @@
 #include "vcl/impprn.hxx"
 #include <boost/bind.hpp>
 
-@interface AquaPrintView : NSView
-{
-    ImplQPrinter*       mpQPrinter;
-    AquaSalInfoPrinter* mpInfoPrinter;
-}
--(id)initWithQPrinter: (ImplQPrinter*)pPrinter withInfoPrinter: (AquaSalInfoPrinter*)pInfoPrinter;
--(MacOSBOOL)knowsPageRange: (NSRangePointer)range;
--(NSRect)rectForPage: (int)page;
--(NSPoint)locationOfPrintRect: (NSRect)aRect;
--(void)drawRect: (NSRect)rect;
-@end
-
-@implementation AquaPrintView
--(id)initWithQPrinter: (ImplQPrinter*)pPrinter withInfoPrinter: (AquaSalInfoPrinter*)pInfoPrinter
-{
-    NSRect aRect = { { 0, 0 }, [pInfoPrinter->getPrintInfo() paperSize] };
-    if( (self = [super initWithFrame: aRect]) != nil )
-    {
-        mpQPrinter = pPrinter;
-        mpInfoPrinter = pInfoPrinter;
-    }
-    return self;
-}
-
--(MacOSBOOL)knowsPageRange: (NSRangePointer)range
-{
-    range->location = 1;
-    range->length = mpQPrinter->GetPrintPageCount();
-    return YES;
-}
-
--(NSRect)rectForPage: (int)page
-{
-    NSRect aRect = { { 0, 0 }, [mpInfoPrinter->getPrintInfo() paperSize] };
-    return aRect;
-}
-
--(NSPoint)locationOfPrintRect: (NSRect)aRect
-{
-    NSPoint aPoint = { 0, 0 };
-    return aPoint;
-}
-
--(void)drawRect: (NSRect)rect
-{
-    NSPoint aPoint = [self locationOfPrintRect: rect];
-    mpQPrinter->PrintNextPage();
-}
-@end
-
-
 // =======================================================================
 
 AquaSalInfoPrinter::AquaSalInfoPrinter( const SalPrinterQueueInfo& i_rQueue ) :
@@ -413,12 +363,12 @@
                      fYScaling = static_cast<double>(nDPIY)/72.0;
 
         NSSize aPaperSize = [mpPrintInfo paperSize];
-        o_rPageWidth  = double(aPaperSize.width) * fXScaling;
-        o_rPageHeight = double(aPaperSize.height) * fYScaling;
-        o_rPageOffX   = [mpPrintInfo leftMargin] * fXScaling;
-        o_rPageOffY   = [mpPrintInfo topMargin] * fYScaling;
-        o_rOutWidth   = o_rPageWidth - double([mpPrintInfo leftMargin] + [mpPrintInfo rightMargin]) * fXScaling;
-        o_rOutHeight  = o_rPageHeight - double([mpPrintInfo topMargin] + [mpPrintInfo bottomMargin]) * fYScaling;
+        o_rPageWidth  = static_cast<long>( double(aPaperSize.width) * fXScaling );
+        o_rPageHeight = static_cast<long>( double(aPaperSize.height) * fYScaling );
+        o_rPageOffX   = static_cast<long>( [mpPrintInfo leftMargin] * fXScaling );
+        o_rPageOffY   = static_cast<long>( [mpPrintInfo topMargin] * fYScaling );
+        o_rOutWidth   = static_cast<long>( o_rPageWidth - double([mpPrintInfo leftMargin] + [mpPrintInfo rightMargin]) * fXScaling );
+        o_rOutHeight  = static_cast<long>( o_rPageHeight - double([mpPrintInfo topMargin] + [mpPrintInfo bottomMargin]) * fYScaling );
     }
 }
 
diff -x CVS -x wntmsci3 -x wntmsci7 -x wntmsci8 -urN ooo_SRC680_m233_src.orig/vcl/aqua/source/window/makefile.mk ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/makefile.mk
--- ooo_SRC680_m233_src.orig/vcl/aqua/source/window/makefile.mk	2007-07-05 10:31:09.000000000 +0200
+++ ooo_SRC680_m233_src.aquavcl04/vcl/aqua/source/window/makefile.mk	2007-10-15 15:24:25.000000000 +0200
@@ -57,7 +57,9 @@
 
 SLOFILES=	\
 		$(SLO)/salframe.obj		\
+		$(SLO)/salframeview.obj	\
 		$(SLO)/salmenu.obj		\
+		$(SLO)/salnsmenu.obj		\
 		$(SLO)/salobj.obj
 
 .ENDIF		# "$(GUIBASE)"!="aqua"
